library FixSignedBoolean;

{$mode objfpc}{$H+}

uses
	Windows,
	SysUtils,
	ModuleUtils;

procedure PatchMemory(lpBaseAddress: Pointer; lpBuffer: Pointer; nSize: PTRUINT);
begin
	if not WriteProcessMemory(GetCurrentProcess, lpBaseAddress, lpBuffer, nSize, PDword(nil)^)
		then raise Exception.CreateFmt(
		'Failed to write %d bytes to memory at address %.P.', [
		nSize,
		lpBaseAddress
	]);
end;

procedure Crash(Error: Exception);
begin
	MessageBoxW(
		0,
		PWideChar(UnicodeString(Error.Message)),
		PWideChar(UnicodeString('Error!')),
		MB_ICONERROR
	);
	raise Error;
end;

procedure MakeGood;
var
	GameBase: Pointer;
	GoodByte: Byte = $95;
begin
	try
		GameBase:= GetModule(GetCurrentProcessId, 'Game.dll').modBaseAddr;
		PatchMemory(GameBase + $3CA172 + 1, @GoodByte, SizeOf(GoodByte)); // StoreBoolean
		PatchMemory(GameBase + $3CA2A5 + 1, @GoodByte, SizeOf(GoodByte)); // SaveBoolean
	except
		on e: Exception do begin
			e.Message:= 'Failed to fix signed booleans.'#13#10 + e.Message;
		end;
	end;
end;

begin
	try
		MakeGood;
	except
		on e: Exception do Crash(e);
	end;
end.

